-------------------------------------------------------------------------------
-- DATABASE MIGRATION
--
-- This is the database migration script for the TPC-R tables.  All changes to
-- the TPC-R database will be found here.
-------------------------------------------------------------------------------

------ Change Log -------------------------------------------------------------
--  Flag  Track   Staff            Date        Description
-- ------ -----  -------------  ----------  -----------------------------------
--  none  26545  Todd Schlomer  2007/05/02   Added site location field and table
-------------------------------------------------------------------------------

-- ___CSMUSER Table___
ALTER TABLE REPMGR.CSMUSER
  ADD COLUMN "NAME" VARCHAR (255) NOT NULL WITH DEFAULT 'nobody';
ALTER TABLE REPMGR.CSMUSER
  ADD COLUMN "TYPE" INTEGER NOT NULL WITH DEFAULT 0;
ALTER TABLE REPMGR.CSMUSER
  ADD COLUMN "PERMISSION" VARCHAR(255) NOT NULL WITH DEFAULT 'com.ibm.csm.common.permission.LogonPermission';
ALTER TABLE REPMGR.CSMUSER
  ADD COLUMN "RESOURCE" VARCHAR(255) NOT NULL WITH DEFAULT '  LOGON  ';
ALTER TABLE REPMGR.CSMUSER
  ADD COLUMN "ACTIONS" VARCHAR(255) NOT NULL WITH DEFAULT 'none';

ALTER TABLE REPMGR.CSMUSER DROP PRIMARY KEY;

ALTER TABLE REPMGR.CSMUSER
  ADD CONSTRAINT PK_CSMUSER PRIMARY KEY (NAME, TYPE, PERMISSION, RESOURCE);

--I cannot seem to get the DROP syntax to work, It appears correct according to the SQL spec
-- ALTER TABLE REPMGR.CSMUSER DROP COLUMN "USERNAME";
-- ALTER TABLE REPMGR.CSMUSER DROP COLUMN "PASSWORD";
-- ALTER TABLE REPMGR.CSMUSER DROP COLUMN "ROLE";

-- ___ SESSION1 Table ____
--To Change the CopyRules size of the blob the following is required:
--Start:
CREATE TABLE TMP_SESSION1
  (SESSIONNAME VARCHAR(250) NOT NULL,
   COPYRULES BLOB(100000),
   CMDBEINGPROCESSED VARCHAR(250),
   STATE VARCHAR(250),
   DESCRIPTION VARCHAR(250),
   PRODUCTIONROLE VARCHAR(250),
   NUMACTIVEDRIVERS INTEGER NOT NULL,
   INUSE SMALLINT NOT NULL,
   INGENERATE VARCHAR(250));

INSERT INTO TMP_SESSION1 SELECT * FROM REPMGR.SESSION1;

DROP TABLE REPMGR.SESSION1;

CREATE TABLE REPMGR.SESSION1
  (SESSIONNAME VARCHAR(250) NOT NULL,
   COPYRULES BLOB(100000),
   CMDBEINGPROCESSED VARCHAR(250),
   STATE VARCHAR(250),
   DESCRIPTION VARCHAR(250),
   PRODUCTIONROLE VARCHAR(250),
   NUMACTIVEDRIVERS INTEGER NOT NULL,
   INUSE SMALLINT NOT NULL,
   INGENERATE VARCHAR(250));

ALTER TABLE REPMGR.SESSION1
  ADD CONSTRAINT PK_SESSION1 PRIMARY KEY (SESSIONNAME);

INSERT INTO REPMGR.SESSION1 SELECT * FROM TMP_SESSION1;
DROP TABLE TMP_SESSION1;
-- Finished modifying the COPYRYLES BLOB size.

-- ___ SITELOCATIONS Table ____
CREATE TABLE REPMGR.SITELOCATIONS
  (SITELOCATIONID SMALLINT NOT NULL,
   SESSIONNAME VARCHAR (250) NOT NULL,
   SITENAME VARCHAR(20) NOT NULL);

ALTER TABLE REPMGR.SITELOCATIONS
  ADD CONSTRAINT PK_SITELOCATIONS PRIMARY KEY (SESSIONNAME, SITENAME, SITELOCATIONID);

-- ###########################################
-- RMTable_bak.ddl Changes
-- ###########################################

-- ___CSMUSER_bak Table___
ALTER TABLE REPMGR.CSMUSER_bak
  ADD COLUMN "NAME" VARCHAR (255) NOT NULL WITH DEFAULT 'nobody';
ALTER TABLE REPMGR.CSMUSER_bak
  ADD COLUMN "TYPE" INTEGER NOT NULL WITH DEFAULT 0;
ALTER TABLE REPMGR.CSMUSER_bak
  ADD COLUMN "PERMISSION" VARCHAR(255) NOT NULL WITH DEFAULT 'com.ibm.csm.common.permission.LogonPermission';
ALTER TABLE REPMGR.CSMUSER_bak
  ADD COLUMN "RESOURCE" VARCHAR(255) NOT NULL WITH DEFAULT '  LOGON  ';
ALTER TABLE REPMGR.CSMUSER_bak
  ADD COLUMN "ACTIONS" VARCHAR(255) NOT NULL WITH DEFAULT 'none';

ALTER TABLE REPMGR.CSMUSER_bak DROP PRIMARY KEY;

ALTER TABLE REPMGR.CSMUSER_bak
  ADD CONSTRAINT PK_CSMUSER_bak PRIMARY KEY (NAME, TYPE, PERMISSION, RESOURCE);

--I cannot seem to get the DROP syntax to work, It appears correct according to the SQL spec
-- ALTER TABLE REPMGR.CSMUSER_bak DROP COLUMN "USERNAME";
-- ALTER TABLE REPMGR.CSMUSER_bak DROP COLUMN "PASSWORD";
-- ALTER TABLE REPMGR.CSMUSER_bak DROP COLUMN "ROLE";

-- ___ SESSION1 Table ____
--To Change the CopyRules size of the blob the following is required:
--Start:
CREATE TABLE TMP_SESSION1_bak
  (SESSIONNAME VARCHAR(250) NOT NULL,
   COPYRULES BLOB(100000),
   CMDBEINGPROCESSED VARCHAR(250),
   STATE VARCHAR(250),
   DESCRIPTION VARCHAR(250),
   PRODUCTIONROLE VARCHAR(250),
   NUMACTIVEDRIVERS INTEGER NOT NULL,
   INUSE SMALLINT NOT NULL,
   INGENERATE VARCHAR(250));

INSERT INTO TMP_SESSION1_bak SELECT * FROM REPMGR.SESSION1_bak;

DROP TABLE REPMGR.SESSION1_bak;

CREATE TABLE REPMGR.SESSION1_bak
  (SESSIONNAME VARCHAR(250) NOT NULL,
   COPYRULES BLOB(100000),
   CMDBEINGPROCESSED VARCHAR(250),
   STATE VARCHAR(250),
   DESCRIPTION VARCHAR(250),
   PRODUCTIONROLE VARCHAR(250),
   NUMACTIVEDRIVERS INTEGER NOT NULL,
   INUSE SMALLINT NOT NULL,
   INGENERATE VARCHAR(250));

ALTER TABLE REPMGR.SESSION1_bak
  ADD CONSTRAINT PK_SESSION1_bak PRIMARY KEY (SESSIONNAME);

INSERT INTO REPMGR.SESSION1_bak SELECT * FROM TMP_SESSION1_bak;
DROP TABLE TMP_SESSION1_bak;
-- Finished modifying the COPYRYLES BLOB size.

-- ___ SITELOCATIONS Table ____
CREATE TABLE REPMGR.SITELOCATIONS_bak
  (SITELOCATIONID SMALLINT NOT NULL,
   SESSIONNAME VARCHAR (250) NOT NULL,
   SITENAME VARCHAR(20) NOT NULL);

ALTER TABLE REPMGR.SITELOCATIONS_bak
  ADD CONSTRAINT PK_SITELOCS_bak PRIMARY KEY (SESSIONNAME, SITENAME, SITELOCATIONID);

-- ###########################################
-- ECTable.ddl Changes
-- ###########################################

-- ___ELEMENTS Table___

ALTER TABLE EC.ELEMENTS
  ADD COLUMN ISPROTECTED SMALLINT NOT NULL WITH DEFAULT 0;
ALTER TABLE EC.ELEMENTS
  ADD COLUMN PROTECTIONBY VARCHAR (32) NOT NULL WITH DEFAULT 'nobody';
ALTER TABLE EC.ELEMENTS
  ADD COLUMN SITELOCATIONID SMALLINT NOT NULL WITH DEFAULT 0;
ALTER TABLE EC.ELEMENTS
  ADD COLUMN ISSPACEEFFICIENT SMALLINT NOT NULL WITH DEFAULT 0;

DROP INDEX EC.IDXELEM;
CREATE INDEX EC.IDXELEM ON EC.ELEMENTS
        (INTERNALNAME ASC, PARENTID ASC, BASETYPE ASC, SPECIFICTYPE1 ASC);


-- #############
-- Rename the ELEMENTS table to save off the data.
ALTER TABLE EC.ELEMENTS DROP CONSTRAINT PK_ELEMENTS;
DROP INDEX EC.IDXELEM;
RENAME TABLE EC.ELEMENTS to TMP_ELEMENTS;

-- Now drop the original table and recreate.
CREATE TABLE EC.ELEMENTS
  (INTERNALNAME VARCHAR(250) NOT NULL,
   ELEMENTID VARCHAR(250) NOT NULL,
   PARENTID VARCHAR(250),
   NICKNAME VARCHAR(250),
   BASETYPE VARCHAR(250),
   SPECIFICTYPE1 VARCHAR(250),
   CAPACITY VARCHAR(250),
   CAPACITYTYPE VARCHAR(250),
   ISALIVE SMALLINT NOT NULL,
   ISPROTECTED SMALLINT NOT NULL DEFAULT 0,
   PROTECTIONBY VARCHAR(32) NOT NULL DEFAULT 'nobody',
   SITELOCATIONID SMALLINT NOT NULL DEFAULT 0,
   ISSPACEEFFICIENT SMALLINT NOT NULL DEFAULT 0,
   SUPERPARENTID VARCHAR(250),
   ELEMENTTYPE VARCHAR(250));

ALTER TABLE EC.ELEMENTS
  ADD CONSTRAINT PK_ELEMENTS PRIMARY KEY (ELEMENTID);

CREATE INDEX EC.IDXELEM ON EC.ELEMENTS 
	(INTERNALNAME ASC, PARENTID ASC, BASETYPE ASC, SPECIFICTYPE1 ASC);

-- Copy the data back into the EC.ELEMENTS table
INSERT INTO EC.ELEMENTS 
	(INTERNALNAME,ELEMENTID,PARENTID,NICKNAME,BASETYPE,SPECIFICTYPE1,
         CAPACITY,CAPACITYTYPE,ISALIVE,ISPROTECTED,PROTECTIONBY,SITELOCATIONID,
         SUPERPARENTID,ELEMENTTYPE,ISSPACEEFFICIENT) 
    SELECT INTERNALNAME,ELEMENTID,PARENTID,NICKNAME,BASETYPE,SPECIFICTYPE1,
	 CAPACITY,CAPACITYTYPE,ISALIVE,ISPROTECTED,PROTECTIONBY,SITELOCATIONID,
	 SUPERPARENTID,ELEMENTTYPE,ISSPACEEFFICIENT
	FROM EC.TMP_ELEMENTS;

-- Clean up the temporary table
DROP TABLE EC.TMP_ELEMENTS;

-- __SITELOCATION Table__
CREATE TABLE EC.SITELOCATION
  (SITELOCATIONID SMALLINT NOT NULL,
  SITENAME VARCHAR (250) NOT NULL);

ALTER TABLE EC.SITELOCATION
  ADD CONSTRAINT PK_SITELOCATION PRIMARY KEY (SITELOCATIONID);
ALTER TABLE EC.SITELOCATION
  ADD CONSTRAINT UN_SITELOCATION UNIQUE (SITENAME);


-- ###########################################
-- ECTable_bak.ddl Changes
-- ###########################################

-- ___ELEMENTS_bak Table___
ALTER TABLE EC.ELEMENTS_bak
  ADD COLUMN ISPROTECTED SMALLINT NOT NULL WITH DEFAULT 0;
ALTER TABLE EC.ELEMENTS_bak
  ADD COLUMN PROTECTIONBY VARCHAR (32) NOT NULL WITH DEFAULT 'nobody';
ALTER TABLE EC.ELEMENTS_bak
  ADD COLUMN SITELOCATIONID SMALLINT NOT NULL WITH DEFAULT 0;
ALTER TABLE EC.ELEMENTS_bak
  ADD COLUMN ISSPACEEFFICIENT SMALLINT NOT NULL WITH DEFAULT 0;

-- #############
-- Rename the ELEMENTS_bak table to save off the data.
ALTER TABLE EC.ELEMENTS_bak DROP CONSTRAINT PK_ELEMENTS_bak;
DROP INDEX EC.IDXELEM_bak;
RENAME TABLE EC.ELEMENTS_bak to TMP_ELEMENTS_bak;

-- Now drop the original table and recreate.
CREATE TABLE EC.ELEMENTS_bak
  (INTERNALNAME VARCHAR(250) NOT NULL,
   ELEMENTID VARCHAR(250) NOT NULL,
   PARENTID VARCHAR(250),
   NICKNAME VARCHAR(250),
   BASETYPE VARCHAR(250),
   SPECIFICTYPE1 VARCHAR(250),
   CAPACITY VARCHAR(250),
   CAPACITYTYPE VARCHAR(250),
   ISALIVE SMALLINT NOT NULL,
   ISPROTECTED SMALLINT NOT NULL DEFAULT 0,
   PROTECTIONBY VARCHAR(32) NOT NULL DEFAULT 'nobody',
   SITELOCATIONID SMALLINT NOT NULL DEFAULT 0,
   ISSPACEEFFICIENT SMALLINT NOT NULL DEFAULT 0,
   SUPERPARENTID VARCHAR(250),
   ELEMENTTYPE VARCHAR(250));

ALTER TABLE EC.ELEMENTS_bak
  ADD CONSTRAINT PK_ELEMENTS_bak PRIMARY KEY (ELEMENTID);

CREATE INDEX EC.IDXELEM_bak ON EC.ELEMENTS_bak 
	(INTERNALNAME ASC, PARENTID ASC, BASETYPE ASC, SPECIFICTYPE1 ASC);

-- Copy the data back into the EC.ELEMENTS table
INSERT INTO EC.ELEMENTS_bak 
	(INTERNALNAME,ELEMENTID,PARENTID,NICKNAME,BASETYPE,SPECIFICTYPE1,
         CAPACITY,CAPACITYTYPE,ISALIVE,ISPROTECTED,PROTECTIONBY,SITELOCATIONID,
         SUPERPARENTID,ELEMENTTYPE,ISSPACEEFFICIENT) 
    SELECT INTERNALNAME,ELEMENTID,PARENTID,NICKNAME,BASETYPE,SPECIFICTYPE1,
	 CAPACITY,CAPACITYTYPE,ISALIVE,ISPROTECTED,PROTECTIONBY,SITELOCATIONID,
	 SUPERPARENTID,ELEMENTTYPE,ISSPACEEFFICIENT
	FROM EC.TMP_ELEMENTS_bak;

-- Clean up the temporary table
DROP TABLE EC.TMP_ELEMENTS_bak;


-- __SITELOCATION Table__
CREATE TABLE EC.SITELOCATION_bak
  (SITELOCATIONID SMALLINT NOT NULL,
  SITENAME VARCHAR (250) NOT NULL);

ALTER TABLE EC.SITELOCATION_bak
  ADD CONSTRAINT PK_SITELOCATION_bak PRIMARY KEY (SITELOCATIONID);
ALTER TABLE EC.SITELOCATION_bak
  ADD CONSTRAINT UN_SITELOCATION_bak UNIQUE (SITENAME);

-- ###########################################
-- HWTable.ddl Changes
-- ###########################################

-- ___ESSSERVERMAPPING___
DROP INDEX ESSHWL.ESSSMIDX;
CREATE INDEX ESSHWL.ESSSMIDX on ESSHWL.ESSSERVERMAPPING
  (ESSNAME ASC, SERVERLOCATION ASC);

-- ___SERVERLOCATIONMAPPING___
ALTER TABLE ESSHWL.SERVERLOCATIONMAPPING
        ADD COLUMN SITELOCATIONID SMALLINT NOT NULL WITH DEFAULT 0;
DROP INDEX ESSHWL.SERVLIDX;
CREATE INDEX ESSHWL.SERVLIDX ON ESSHWL.SERVERLOCATIONMAPPING
        (SERVERLOCATION ASC, HOSTNAMECLUSTER0 ASC, HOSTNAMECLUSTER1 ASC, SERVERTYPE ASC);

-- ___ASYNCMASTERQUERYMONITOR___
DROP INDEX ESSHWL.ASCMQIDX;
CREATE INDEX ESSHWL.ASCMQIDX ON ESSHWL.ASYNCMASTERQUERYMONITOR
        (ESSNAME ASC, SESSIONNUMBER ASC, QUERYISRUNNING ASC);

-- ###########################################
-- HWTable_bak.ddl Changes
-- ###########################################
-- ___SERVERLOCATIONMAPPING_bak___
ALTER TABLE ESSHWL.SERVERLOCATIONMAPPING_bak
        ADD COLUMN SITELOCATIONID SMALLINT NOT NULL WITH DEFAULT 0;

-- ###########################################
-- SVCHWTable.ddl Changes
-- ###########################################
-- ___LSSSERVERLOCATIONMAPPING___
ALTER TABLE SVCHWL.LSSERVERLOCATIONMAPPING
        ADD COLUMN SITELOCATIONID SMALLINT NOT NULL WITH DEFAULT 0;

-- ###########################################
-- SVCHWTable_bak.ddl Changes
-- ###########################################
-- ___LSSSERVERLOCATIONMAPPING_bak___
ALTER TABLE SVCHWL.LSSERVERLOCATIONMAPPING_bak
        ADD COLUMN SITELOCATIONID SMALLINT NOT NULL WITH DEFAULT 0;
        
        
        
-- ___ DRIVER Table ____
--To Change the driver table to have sequencename a primary key:
--Start:
CREATE TABLE TMP_DRIVER
  (DRIVERID VARCHAR(250) NOT NULL,
   TYPE1 VARCHAR(250),
   ISSHADOWING SMALLINT NOT NULL,
   CONTROLCLASS VARCHAR(250),
   NUMBEROFPAIRS INTEGER NOT NULL,
   CGINFO BLOB(50000),
   SEQUENCENAME VARCHAR(250) NOT NULL,
   SESSIONNAME VARCHAR(250) NOT NULL,
   ISDEFINED SMALLINT NOT NULL,
   TIMESTAMP1 VARCHAR(250),
   INUSE SMALLINT NOT NULL,
   HWCONSISTENCYGROUPNAME VARCHAR(250),
   ISNEW SMALLINT NOT NULL);

INSERT INTO TMP_DRIVER SELECT * FROM REPMGR.DRIVER;

DROP TABLE REPMGR.DRIVER;

CREATE TABLE REPMGR.DRIVER
  (DRIVERID VARCHAR(250) NOT NULL,
   TYPE1 VARCHAR(250),
   ISSHADOWING SMALLINT NOT NULL,
   CONTROLCLASS VARCHAR(250),
   NUMBEROFPAIRS INTEGER NOT NULL,
   CGINFO BLOB(50000),
   SEQUENCENAME VARCHAR(250) NOT NULL,
   SESSIONNAME VARCHAR(250) NOT NULL,
   ISDEFINED SMALLINT NOT NULL,
   TIMESTAMP1 VARCHAR(250),
   INUSE SMALLINT NOT NULL,
   HWCONSISTENCYGROUPNAME VARCHAR(250),
   ISNEW SMALLINT NOT NULL);

ALTER TABLE REPMGR.DRIVER
  ADD CONSTRAINT PK_DRIVER PRIMARY KEY (DRIVERID, SESSIONNAME, SEQUENCENAME);

INSERT INTO REPMGR.DRIVER SELECT * FROM TMP_DRIVER;
DROP TABLE TMP_DRIVER;


CREATE TABLE TMP_DRIVER_bak
  (DRIVERID VARCHAR(250) NOT NULL,
   TYPE1 VARCHAR(250),
   ISSHADOWING SMALLINT NOT NULL,
   CONTROLCLASS VARCHAR(250),
   NUMBEROFPAIRS INTEGER NOT NULL,
   CGINFO BLOB(50000),
   SEQUENCENAME VARCHAR(250) NOT NULL,
   SESSIONNAME VARCHAR(250) NOT NULL,
   ISDEFINED SMALLINT NOT NULL,
   TIMESTAMP1 VARCHAR(250),
   INUSE SMALLINT NOT NULL,
   HWCONSISTENCYGROUPNAME VARCHAR(250),
   ISNEW SMALLINT NOT NULL);

INSERT INTO TMP_DRIVER_bak SELECT * FROM REPMGR.DRIVER_bak;

DROP TABLE REPMGR.DRIVER_bak;

CREATE TABLE REPMGR.DRIVER_bak
  (DRIVERID VARCHAR(250) NOT NULL,
   TYPE1 VARCHAR(250),
   ISSHADOWING SMALLINT NOT NULL,
   CONTROLCLASS VARCHAR(250),
   NUMBEROFPAIRS INTEGER NOT NULL,
   CGINFO BLOB(50000),
   SEQUENCENAME VARCHAR(250) NOT NULL,
   SESSIONNAME VARCHAR(250) NOT NULL,
   ISDEFINED SMALLINT NOT NULL,
   TIMESTAMP1 VARCHAR(250),
   INUSE SMALLINT NOT NULL,
   HWCONSISTENCYGROUPNAME VARCHAR(250),
   ISNEW SMALLINT NOT NULL);

ALTER TABLE REPMGR.DRIVER_bak
  ADD CONSTRAINT PK_DRIVER_bak PRIMARY KEY (DRIVERID, SESSIONNAME, SEQUENCENAME);

INSERT INTO REPMGR.DRIVER_bak SELECT * FROM TMP_DRIVER_bak;
DROP TABLE TMP_DRIVER_bak;


-- Finished modifying the driver.
