-------------------------------------------------------------------------------
-- EC.ELEMENTS
--
-- This is the database setup script for the EC schema.
-------------------------------------------------------------------------------

------ Change Log -------------------------------------------------------------
--  Flag  Track   Staff            Date        Description
-- ------ -----  -------------  ----------  -----------------------------------
--  none         J Brundidge    2005/04/01   Initial Creation
--  none  23232  Todd Schlomer  2006/07/06   New protection fields and index
--  none  23325  Jay Calder		2006/07/14	 Removed extra index parameters
--  none  23341  Todd Schlomer  2006/07/17   Added site location field and table
--	none	  23536	 Jay Calder		2006/08/07   Split the alter table statement
-------------------------------------------------------------------------------

CREATE SCHEMA EC;

DROP TABLE EC.ELEMENTS;
CREATE TABLE EC.ELEMENTS
  (INTERNALNAME VARCHAR(250) NOT NULL,
   ELEMENTID VARCHAR(250) NOT NULL,
   PARENTID VARCHAR(250),
   NICKNAME VARCHAR(250),
   BASETYPE VARCHAR(250),
   SPECIFICTYPE1 VARCHAR(250),
   CAPACITY VARCHAR(250),
   CAPACITYTYPE VARCHAR(250),
   ISALIVE SMALLINT NOT NULL,
   ISPROTECTED SMALLINT NOT NULL DEFAULT 0,
   PROTECTIONBY VARCHAR(32) NOT NULL DEFAULT 'nobody',
   SITELOCATIONID SMALLINT NOT NULL DEFAULT 0,
   SUPERPARENTID VARCHAR(250),
   ELEMENTTYPE VARCHAR(250),
   TOTALBYTES BIGINT NOT NULL DEFAULT 0);

ALTER TABLE EC.ELEMENTS
  ADD CONSTRAINT PK_ELEMENTS PRIMARY KEY (ELEMENTID);

CREATE INDEX EC.IDXELEM ON EC.ELEMENTS 
	(INTERNALNAME ASC, PARENTID ASC, BASETYPE ASC, SPECIFICTYPE1 ASC);

DROP TABLE EC.SITELOCATION;
CREATE TABLE EC.SITELOCATION 
   (SITELOCATIONID SMALLINT NOT NULL, 
    SITENAME VARCHAR (250) NOT NULL);

ALTER TABLE EC.SITELOCATION
  ADD CONSTRAINT PK_SITELOCATION PRIMARY KEY (SITELOCATIONID);
ALTER TABLE EC.SITELOCATION
  ADD CONSTRAINT UN_SITELOCATION UNIQUE (SITENAME);