-------------------------------------------------------------------------------
-- SVCHWL backup tables
--
-- This is the backup table setup script for the normal SVCHWL schema tables.
-------------------------------------------------------------------------------

------ Change Log -------------------------------------------------------------
--  Flag  Track   Staff            Date        Description
-- ------ -----  -------------  ----------  -----------------------------------
--  none  23158  Todd Schlomer  2006/06/23   Initial Creation
--  none  23341  Todd Schlomer  2006/07/17   Added site location support
-------------------------------------------------------------------------------

CREATE SCHEMA SVCHWL;

DROP TABLE SVCHWL.LSSERVERLOCATIONMAPPING_bak;
CREATE TABLE SVCHWL.LSSERVERLOCATIONMAPPING_bak
  (SERVERLOCATION VARCHAR(250) NOT NULL,
   USERNAME VARCHAR(250),
   PASSWORD VARCHAR(250),
   UNIQUENAME VARCHAR(250),
   NOTIFICATIONPORT INTEGER,
   SITELOCATIONID SMALLINT NOT NULL DEFAULT 0);

ALTER TABLE SVCHWL.LSSERVERLOCATIONMAPPING_bak
  ADD CONSTRAINT PK_LSSERVERLOC_bak PRIMARY KEY (SERVERLOCATION);

DROP TABLE SVCHWL.CLUSTERSERVERMAPPING_bak;
CREATE TABLE SVCHWL.CLUSTERSERVERMAPPING_bak
  (CLUSTERNAME VARCHAR(250) NOT NULL,
   SERVERLOCATION VARCHAR(250) NOT NULL);

ALTER TABLE SVCHWL.CLUSTERSERVERMAPPING_bak
  ADD CONSTRAINT PK_CLUSTERSERV_bak PRIMARY KEY (CLUSTERNAME, SERVERLOCATION);